## org.apache.commons.math.distribution
Class GammaDistributionImpl

    java.lang.Object
      org.apache.commons.math.distribution.AbstractDistribution
          org.apache.commons.math.distribution.AbstractContinuousDistribution
              org.apache.commons.math.distribution.GammaDistributionImpl

All Implemented Interfaces:
  java.io.Serializable, ContinuousDistribution, Distribution, GammaDistribution, HasDensity<java.lang.Double>

    public class GammaDistributionImpl

extends AbstractContinuousDistribution
implements GammaDistribution, java.io.Serializable

The default implementation of `GammaDistribution`.

Version:
  $Revision: 772119 $ $Date: 2009-05-06 05:43:28 -0400 (Wed, 06 May 2009) $
See Also:
  Serialized Form

Field Summary
`private double` `alpha` The shape parameter.
`private double` `beta` The scale parameter.
`private static long` `serialVersionUID` Serializable version identifier

Constructor Summary
`GammaDistributionImpl(double alpha, double beta)` Create a new gamma distribution with the given alpha and beta values.

Method Summary
`double` `cumulativeProbability(double x)` For this distribution, X, this method returns P(X < x).
`double` `density(java.lang.Double x)` Return the probability density for a particular point.
`double` `getAlpha()` Access the shape parameter, alpha
`double` `getBeta()` Access the scale parameter, beta
`protected double` `getDomainLowerBound(double p)` Access the domain value lower bound, based on `p`, used to bracket a CDF root.
`protected double` `getDomainUpperBound(double p)` Access the domain value upper bound, based on `p`, used to bracket a CDF root.
`protected double` `getInitialDomain(double p)` Access the initial domain value, based on `p`, used to bracket a CDF root.
`double` `inverseCumulativeProbability(double p)` For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.
`void` `setAlpha(double alpha)` Modify the shape parameter, alpha.
`void` `setBeta(double beta)` Modify the scale parameter, beta.

Methods inherited from class org.apache.commons.math.distribution.AbstractDistribution
`cumulativeProbability`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.distribution.Distribution
`cumulativeProbability`

Field Detail

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### alpha

    private double alpha

  The shape parameter.

### beta

    private double beta

  The scale parameter.

Constructor Detail

### GammaDistributionImpl

    public GammaDistributionImpl(double alpha,
                                 double beta)

  Create a new gamma distribution with the given alpha and beta values.

  Parameters:
    `alpha` - the shape parameter.
    `beta` - the scale parameter.

Method Detail

### cumulativeProbability

    public double cumulativeProbability(double x)
                                 throws MathException

  For this distribution, X, this method returns P(X < x). The implementation of this method is based on:
  - Chi-Squared Distribution, equation (9).
  - Casella, G., & Berger, R. (1990). Statistical Inference. Belmont, CA: Duxbury Press.

  Specified by:
    `cumulativeProbability` in interface `Distribution`
  Parameters:
    `x` - the value at which the CDF is evaluated.
  Returns:
    CDF for this distribution.
  Throws:
    `MathException` - if the cumulative probability can not be computed due to convergence or other numerical errors.

### inverseCumulativeProbability

    public double inverseCumulativeProbability(double p)
                                        throws MathException

  For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.

  Returns 0 for p=0 and `Double.POSITIVE_INFINITY` for p=1.

  Specified by:
    `inverseCumulativeProbability` in interface `ContinuousDistribution`
  Overrides:
    `inverseCumulativeProbability` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability
  Returns:
    x, such that P(X < x) = `p`
  Throws:
    `MathException` - if the inverse cumulative probability can not be computed due to convergence or other numerical errors.
    `java.lang.IllegalArgumentException` - if `p` is not a valid probability.

### setAlpha

    public void setAlpha(double alpha)

  Modify the shape parameter, alpha.

  Specified by:
    `setAlpha` in interface `GammaDistribution`
  Parameters:
    `alpha` - the new shape parameter.
  Throws:
    `java.lang.IllegalArgumentException` - if `alpha` is not positive.

### getAlpha

    public double getAlpha()

  Access the shape parameter, alpha

  Specified by:
    `getAlpha` in interface `GammaDistribution`
  Returns:
    alpha.

### setBeta

    public void setBeta(double beta)

  Modify the scale parameter, beta.

  Specified by:
    `setBeta` in interface `GammaDistribution`
  Parameters:
    `beta` - the new scale parameter.
  Throws:
    `java.lang.IllegalArgumentException` - if `beta` is not positive.

### getBeta

    public double getBeta()

  Access the scale parameter, beta

  Specified by:
    `getBeta` in interface `GammaDistribution`
  Returns:
    beta.

### density

    public double density(java.lang.Double x)

  Return the probability density for a particular point.

  Specified by:
    `density` in interface `GammaDistribution`
  Specified by:
    `density` in interface `HasDensity<java.lang.Double>`
  Parameters:
    `x` - The point at which the density should be computed.
  Returns:
    The pdf at point x.

### getDomainLowerBound

    protected double getDomainLowerBound(double p)

  Access the domain value lower bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainLowerBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value lower bound, i.e. P(X < lower bound) < `p`

### getDomainUpperBound

    protected double getDomainUpperBound(double p)

  Access the domain value upper bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainUpperBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value upper bound, i.e. P(X < upper bound) > `p`

### getInitialDomain

    protected double getInitialDomain(double p)

  Access the initial domain value, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getInitialDomain` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    initial domain value

Copyright (c) 2003-2010 Apache Software Foundation